MultiTemplateLoader (FreeMarker 2.3.35 API)
Description: declaration: package: freemarker.cache, class: MultiTemplateLoader

Package freemarker.cache

# Class MultiTemplateLoader

java.lang.Object
freemarker.cache.MultiTemplateLoader

All Implemented Interfaces:
  `StatefulTemplateLoader`, `TemplateLoader`

public class MultiTemplateLoader extends Object implements StatefulTemplateLoader
A `TemplateLoader` that uses a set of other loaders to load the templates. On every request, loaders are queried in the order of their appearance in the array of loaders provided to the constructor. However, by default, if a request for some template name was already satisfied in the past by one of the loaders, that loader is queried first (stickiness). This behavior can be disabled with `setSticky(boolean)`, then the loaders are always queried in the order of their appearance in the array.

This class is thread-safe.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MultiTemplateLoader​(TemplateLoader[] templateLoaders)`
  Creates a new instance that will use the specified template loaders.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `closeTemplateSource​(Object templateSource)`
  Closes the template source, releasing any resources held that are only required for reading the template and/or its metadata.
  `Object`
  `findTemplateSource​(String name)`
  Finds the template in the backing storage and returns an object that identifies the storage location where the template can be loaded from.
  `long`
  `getLastModified​(Object templateSource)`
  Returns the time of last modification of the specified template source.
  `Reader`
  `getReader​(Object templateSource, String encoding)`
  Returns the character stream of a template represented by the specified template source.
  `TemplateLoader`
  `getTemplateLoader​(int index)`
  Returns the `TemplateLoader` at the given index.
  `int`
  `getTemplateLoaderCount()`
  Returns the number of `TemplateLoader`-s directly inside this `TemplateLoader`.
  `boolean`
  `isSticky()`
  Getter pair of `setSticky(boolean)`.
  `void`
  `resetState()`
  Clears the sickiness memory, also resets the state of all enclosed `StatefulTemplateLoader`-s.
  `void`
  `setSticky​(boolean sticky)`
  Sets if for a name that was already loaded earlier the same `TemplateLoader` will be tried first, or we always try the `TemplateLoader`-s strictly in the order as it was specified in the constructor.
  `String`
  `toString()`
  Show class name and some details that are useful in template-not-found errors.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### MultiTemplateLoader

    public MultiTemplateLoader​(TemplateLoader[] templateLoaders)
    Creates a new instance that will use the specified template loaders.
    Parameters:
      `templateLoaders` - the template loaders that are used to load templates, in the order as they will be searched (except where stickiness says otherwise).

- ## Method Details

  - ### findTemplateSource

    public Object findTemplateSource​(String name) throws IOException
    Description copied from interface: `TemplateLoader`
    Finds the template in the backing storage and returns an object that identifies the storage location where the template can be loaded from. See the return value for more information.
    Specified by:
      `findTemplateSource` in interface `TemplateLoader`
    Parameters:
      `name` - The name (template root directory relative path) of the template, already localized and normalized by the `cache`. It is completely up to the loader implementation to interpret the name, however it should expect to receive hierarchical paths where path components are separated by a slash (not backslash). Backslashes (or any other OS specific separator character) are not considered as separators by FreeMarker, and thus they will not be replaced with slash before passing to this method, so it's up to the template loader to handle them (say, by throwing an exception that tells the user that the path (s)he has entered is invalid, as (s)he must use slash -- typical mistake of Windows users). The passed names are always considered relative to some loader-defined root location (often referred as the "template root directory"), and will never start with a slash, nor will they contain a path component consisting of either a single or a double dot -- these are all resolved by the template cache before passing the name to the loader. As a side effect, paths that trivially reach outside template root directory, such as `../my.ftl`, will be rejected by the template cache, so they never reach the template loader. Note again, that if the path uses backslash as path separator instead of slash as (the template loader should not accept that), the normalization will not properly happen, as FreeMarker (the cache) recognizes only the slashes as separators.
    Returns:
      An object representing the template source, which can be supplied in subsequent calls to `TemplateLoader.getLastModified(Object)` and `TemplateLoader.getReader(Object, String)`, when those are called on the same `TemplateLoader`. `null` must be returned if the source for the template doesn't exist; don't throw exception then! The exact type of this object is up to the `TemplateLoader` implementation. As this object is possibly used as hash key in caches, and is surly compared with another template source for equality, it must have a proper `Object.equals(Object)` and `Object.hashCode()`) implementation. Especially, template sources that refer to the same physical source must be equivalent, otherwise template caching can become inefficient. This is only expected from `Object.equals(Object)` when the compared template sources came from the same `TemplateLoader` instance. Also, it must not influence the equality if the source is open or closed (`TemplateLoader.closeTemplateSource(Object)`).
    Throws:
      `IOException` - When an error occurs that makes it impossible to find out if the template exists, or to access the existing template. Don't throw exception if the template doesn't exist, instead return with `null` then!

  - ### getLastModified

    public long getLastModified​(Object templateSource)
    Description copied from interface: `TemplateLoader`
    Returns the time of last modification of the specified template source. This method is called after `findTemplateSource()`.
    Specified by:
      `getLastModified` in interface `TemplateLoader`
    Parameters:
      `templateSource` - an object representing a template source (the template file), obtained through a prior call to `TemplateLoader.findTemplateSource(String)`. This must be an object on which `TemplateLoader.closeTemplateSource(Object)` wasn't applied yet.
    Returns:
      The time of last modification for the specified template source, or -1 if the time is not known. This value meant to be milliseconds since the epoch, but in fact FreeMarker doesn't care what it means, it only cares if it changes, in which case the template needs to be reloaded (even if the value has decreased). -1 is not special in that regard either; if you keep returning it, FreeMarker won't reload the template (as far as it's not evicted from the cache from some other reason). Note that `Long.MIN_VALUE` is reserved for internal use.

  - ### getReader

    public Reader getReader​(Object templateSource, String encoding) throws IOException
    Description copied from interface: `TemplateLoader`
    Returns the character stream of a template represented by the specified template source. This method is possibly called for multiple times for the same template source object, and it must always return a `Reader` that reads the template from its beginning. Before this method is called for the second time (or later), its caller must close the previously returned `Reader`, and it must not use it anymore. That is, this method is not required to support multiple concurrent readers for the same source `templateSource` object.

    Typically, this method is called if the template is missing from the cache, or if after calling `TemplateLoader.findTemplateSource(String)` and `TemplateLoader.getLastModified(Object)` it was determined that the cached copy of the template is stale. Then, if it turns out that the `encoding` parameter used doesn't match the actual template content (based on the `#ftl encoding=...` header), this method will be called for a second time with the correct `encoding` parameter value.

    Unlike `TemplateLoader.findTemplateSource(String)`, this method must not tolerate if the template is not found, and must throw `IOException` in that case.

    Specified by:
      `getReader` in interface `TemplateLoader`
    Parameters:
      `templateSource` - an object representing a template source, obtained through a prior call to `TemplateLoader.findTemplateSource(String)`. This must be an object on which `TemplateLoader.closeTemplateSource(Object)` wasn't applied yet.
      `encoding` - the character encoding used to translate source bytes to characters. Some loaders may not have access to the byte representation of the template stream, and instead directly obtain a character stream. These loaders should ignore the encoding parameter.
    Returns:
      A `Reader` representing the template character stream; not `null`. It's the responsibility of the caller (which is `TemplateCache` usually) to `close()` it. The `Reader` is not required to work after the `templateSource` was closed (`TemplateLoader.closeTemplateSource(Object)`).
    Throws:
      `IOException` - if an I/O error occurs while accessing the stream.

  - ### closeTemplateSource

    public void closeTemplateSource​(Object templateSource) throws IOException
    Description copied from interface: `TemplateLoader`
    Closes the template source, releasing any resources held that are only required for reading the template and/or its metadata. This is the last method that is called by the `TemplateCache` for a template source, except that `Object.equals(Object)` is might called later too. `TemplateCache` ensures that this method will be called on every object that is returned from `TemplateLoader.findTemplateSource(String)`.
    Specified by:
      `closeTemplateSource` in interface `TemplateLoader`
    Parameters:
      `templateSource` - the template source that should be closed.
    Throws:
      `IOException`

  - ### resetState

    public void resetState()
    Clears the sickiness memory, also resets the state of all enclosed `StatefulTemplateLoader`-s.
    Specified by:
      `resetState` in interface `StatefulTemplateLoader`

  - ### toString

    public String toString()
    Show class name and some details that are useful in template-not-found errors.
    Overrides:
      `toString` in class `Object`
    Since:
      2.3.21

  - ### getTemplateLoaderCount

    public int getTemplateLoaderCount()
    Returns the number of `TemplateLoader`-s directly inside this `TemplateLoader`.
    Since:
      2.3.23

  - ### getTemplateLoader

    public TemplateLoader getTemplateLoader​(int index)
    Returns the `TemplateLoader` at the given index.
    Parameters:
      `index` - Must be below `getTemplateLoaderCount()`.

  - ### isSticky

    public boolean isSticky()
    Getter pair of `setSticky(boolean)`.
    Since:
      2.3.24

  - ### setSticky

    public void setSticky​(boolean sticky)
    Sets if for a name that was already loaded earlier the same `TemplateLoader` will be tried first, or we always try the `TemplateLoader`-s strictly in the order as it was specified in the constructor. The default is `true`.
    Since:
      2.3.24